// Example by Tom Igoe

import processing.serial.*;
import java.util.*;
import java.text.*;
import de.bezier.data.sql.*;


PrintWriter output;
DateFormat fnameFormat= new SimpleDateFormat("yyMMdd_HHmm");
DateFormat  timeFormat = new SimpleDateFormat("hh:mm:ss");
String fileName;

Serial myPort;    // The serial port
PFont myFont;     // The display font
String inString;  // Input string from serial port
int lf = 10;      // ASCII linefeed
PFont font;


MySQL dbconnection;

void setup() {
  size(600,100);
  // println(Serial.list());
  myPort = new Serial(this, Serial.list()[1], 9600);
 myPort.clear();
  // Clear the table data
  String user     = "root";
  String pass     = "";
  String database = "myurov";
  // connect to database of server "localhost"
  dbconnection = new MySQL( this, "localhost", database, user, pass );
     if ( dbconnection.connect() ) {
   dbconnection.query("truncate aptc");  // Clear all of the table data
    dbconnection.close();
     }
  Date now = new Date();
//  fileName = fnameFormat.format(now);
    fileName = "readings";
  output = createWriter(fileName + ".csv"); // save the file in the sketch folder
  myPort.bufferUntil(lf);
}

void draw() {
  background(0);
  text("received: " + inString, 10,50);
  }

void serialEvent(Serial p) {
  delay(1000);
  inString = p.readString();
   String timeString = timeFormat.format(new Date());
   output.print(timeString);
   output.print(",");
   output.println(inString); 
   println("Message received at " + timeString + ": ");
 //  println(inString);
   String readings = (inString);
   String[] list = split(readings, ',');
      println("Barometric Pressure = "+list[0]+" inHg");
      println("Temperature = "+list[1]+"\u00B0 F");
      println("Altitude = "+list[2]+" Ft");
      println("Magnetometer Raw X Axis = "+list[3]+" ");
      println("Magnetometer Raw Y Axis = "+list[4]+" ");
      println("Magnetometer Raw Z Axis = "+list[5]+" ");
      println("Magnetometer Scaled X Axis = "+list[6]+" ");
      println("Magnetometer Scaled Y Axis = "+list[7]+" ");
      println("Magnetometer Scaled Z Axis = "+list[8]+" ");
      println("Magnetometer Heading = "+list[9]+" ");
      println("Magnetometer Heading Degrees = "+list[10]+"\u00B0 Degrees");  // special char for degrees "www.ascii-code.com/"  u00XX = HEX //
      println();
 //  delay(1000);  
        String user     = "root";
        String pass     = "";
        String database = "myurov";
        // connect to database of server "localhost"
        dbconnection = new MySQL( this, "localhost", database, user, pass );

        if ( dbconnection.connect() ) {
          // Clear all of the table data
      // dbconnection.query("truncate aptc");  

          // now send data to database
 
  dbconnection.execute( "INSERT INTO aptc (pressure, temperature, altitude, rxaxis, ryaxis, rzaxis, sxaxis, syaxis, szaxis, heading, hddegrees) VALUES ('"+list[0]+"','"+list[1]+"','"+list[2]+"','"+list[3]+"','"+list[4]+"','"+list[5]+"','"+list[6]+"','"+list[7]+"','"+list[8]+"','"+list[9]+"','"+list[10]+"');" );  
 dbconnection.close();

        }
}

void keyPressed() {
  output.flush(); // Writes the remaining data to the file
  output.close(); // Finishes the file
  exit(); // Stops the program
}

